Index: Makefile
===================================================================
--- Makefile	(revision f0baf5d9a72e3d68eed12e5c089455e54b798330)
+++ Makefile	(revision 869909a5c0147ae4a84eecb12f372c430fd94905)
@@ -77,6 +77,5 @@
 	$(Q)cp images/*.png $(BASEDIR)/images
 
-	$(Q)cd $(BASEDIR)/; sed -e "s@../stylesheets@stylesheets@g" \
-                           -e "s@../images@images@g"           \
+	$(Q)cd $(BASEDIR)/; sed -e "s@../images@images@g"           \
                            -i *.html
 
Index: stylesheets/lfs-xsl/chunk-master.xsl
===================================================================
--- stylesheets/lfs-xsl/chunk-master.xsl	(revision f0baf5d9a72e3d68eed12e5c089455e54b798330)
+++ stylesheets/lfs-xsl/chunk-master.xsl	(revision 869909a5c0147ae4a84eecb12f372c430fd94905)
@@ -19,8 +19,8 @@
 
     <!-- Upstream chunk code named templates -->
-  <xsl:import href="docbook-xsl-snapshot/xhtml/chunk-common.xsl"/>
+  <xsl:import href="http://docbook.sourceforge.net/release/xsl/current/xhtml/chunk-common.xsl"/>
 
     <!-- Upstream chunk code match templates -->
-  <xsl:include href="docbook-xsl-snapshot/xhtml/chunk-code.xsl"/>
+  <xsl:include href="http://docbook.sourceforge.net/release/xsl/current/xhtml/chunk-code.xsl"/>
 
     <!-- Including our customized chunks templates -->
Index: stylesheets/lfs-xsl/chunk-slave.xsl
===================================================================
--- stylesheets/lfs-xsl/chunk-slave.xsl	(revision f0baf5d9a72e3d68eed12e5c089455e54b798330)
+++ stylesheets/lfs-xsl/chunk-slave.xsl	(revision 869909a5c0147ae4a84eecb12f372c430fd94905)
@@ -14,5 +14,5 @@
 
     <!-- Upstream XHTML presentation templates -->
-  <xsl:import href="docbook-xsl-snapshot/xhtml/docbook.xsl"/>
+  <xsl:import href="http://docbook.sourceforge.net/release/xsl/current/xhtml/docbook.xsl"/>
 
     <!-- Use ISO-8859-1 for output instead of default UTF-8 -->
@@ -28,11 +28,11 @@
   <xsl:include href="xhtml/lfs-xref.xsl"/>
 
-    <!-- The CSS Stylesheets. We set here relative path from sub-dirs HTML files.
-    The path from top-level HTML files (index.html, partX.html, etc) MUST be
-    fixed via a sed in the Makefile-->
-    <!-- Master CSS Stylesheet -->
-  <xsl:param name="html.stylesheet" select="'../stylesheets/lfs.css'"/>
-    <!-- Print CSS Stylesheet -->
-    <!-- The original template is in {docbook-xsl}/xhtml/docbook.xsl -->
+  <!-- The CSS Stylesheets. The path is relative to the top level html
+       directory. The templates compute automatically the position of
+       the CSS relative to the current file. So no need to fix the paths
+       in the Makefile. -->
+  <xsl:param name="html.stylesheet" select="'stylesheets/lfs.css'"/>
+    <!-- Print CSS Stylesheet
+    The original template is in {docbook-xsl}/xhtml/docbook.xsl -->
   <xsl:template name='user.head.content'>
      <link rel="stylesheet" href="../stylesheets/lfs-print.css" type="text/css" media="print"/>
Index: stylesheets/lfs-xsl/nochunks.xsl
===================================================================
--- stylesheets/lfs-xsl/nochunks.xsl	(revision f0baf5d9a72e3d68eed12e5c089455e54b798330)
+++ stylesheets/lfs-xsl/nochunks.xsl	(revision 869909a5c0147ae4a84eecb12f372c430fd94905)
@@ -14,5 +14,5 @@
 
     <!-- Upstream XHTML templates -->
-  <xsl:import href="docbook-xsl-snapshot/xhtml/docbook.xsl"/>
+  <xsl:import href="http://docbook.sourceforge.net/release/xsl/current/xhtml/docbook.xsl"/>
 
     <!-- Fix encoding issues with default UTF-8 output of the xhtml stylesheet -->
Index: stylesheets/lfs-xsl/pdf.xsl
===================================================================
--- stylesheets/lfs-xsl/pdf.xsl	(revision f0baf5d9a72e3d68eed12e5c089455e54b798330)
+++ stylesheets/lfs-xsl/pdf.xsl	(revision 869909a5c0147ae4a84eecb12f372c430fd94905)
@@ -15,5 +15,5 @@
     <!-- Upstream FO templates. Profiled version is not supported by
          xsltproc, thus pofiling must be done in two steps (see Makefile) -->
-  <xsl:import href="docbook-xsl-snapshot/fo/docbook.xsl"/>
+  <xsl:import href="http://docbook.sourceforge.net/release/xsl/current/fo/docbook.xsl"/>
 
     <!-- Uncomment the next for debugging the raw FO code.
Index: stylesheets/lfs-xsl/profile.xsl
===================================================================
--- stylesheets/lfs-xsl/profile.xsl	(revision f0baf5d9a72e3d68eed12e5c089455e54b798330)
+++ stylesheets/lfs-xsl/profile.xsl	(revision 869909a5c0147ae4a84eecb12f372c430fd94905)
@@ -13,9 +13,9 @@
 
   <!-- Include common profiling stylesheet -->
-  <xsl:import href="docbook-xsl-snapshot/profiling/profile-mode.xsl"/>
+  <xsl:import href="http://docbook.sourceforge.net/release/xsl/current/profiling/profile-mode.xsl"/>
 
     <!-- This file must be included, because profile-mode is using
          templates from it -->
-  <xsl:import href="docbook-xsl-snapshot/common/stripns.xsl"/>
+  <xsl:import href="http://docbook.sourceforge.net/release/xsl/current/common/stripns.xsl"/>
 
     <!-- In the two pass processing there is no need for base URI fixup -->
Index: stylesheets/lfs-xsl/xhtml/lfs-index.xsl
===================================================================
--- stylesheets/lfs-xsl/xhtml/lfs-index.xsl	(revision f0baf5d9a72e3d68eed12e5c089455e54b798330)
+++ stylesheets/lfs-xsl/xhtml/lfs-index.xsl	(revision 869909a5c0147ae4a84eecb12f372c430fd94905)
@@ -36,8 +36,9 @@
   </xsl:template>
 
-    <!-- The Index title in the longindex.html page:
-           Removed a lot of code not useful for us.
-           Forced h1 title size. -->
-    <!-- The original template is in {docbook-xsl}/xhtml/titlepage.templates.xsl -->
+  <!-- The Index title in the longindex.html page:
+         Removed a lot of code not useful for us.
+         Forced h1 title size.
+       The original template is in {docbook-xsl}/xhtml/titlepage.templates.xsl
+  Use the original template now (as in LFS)
   <xsl:template name="index.titlepage">
     <h1 class="index">
@@ -46,5 +47,5 @@
       </xsl:call-template>
     </h1>
-  </xsl:template>
+  </xsl:template>-->
 
     <!--Divisions:
@@ -132,24 +133,10 @@
       </xsl:if>
       <ul>
-        <xsl:apply-templates select="key('letter', $key)[&scope;] [count(.|key('primary', &primary;)[&scope;][1])=1]"
-                              mode="index-primary">
-          <xsl:with-param name="scope" select="$scope"/>
-          <xsl:sort select="translate(&primary;, &lowercase;, &uppercase;)"/>
-        </xsl:apply-templates>
+      <xsl:apply-templates select="key('letter', $key)[count(ancestor::node()|$scope) = count(ancestor::node())][count(.|key('primary', normalize-space(concat(primary/@sortas, &quot; &quot;, primary)))[count(ancestor::node()|$scope) = count(ancestor::node())][1])=1]" mode="index-primary">
+        <xsl:with-param name="scope" select="$scope"/>
+        <xsl:sort select="translate(&primary;, &lowercase;, &uppercase;)"/>
+      </xsl:apply-templates>
       </ul>
     </xsl:if>
-  </xsl:template>
-
-    <!-- Dropping $term.separator and $number.separator from here.
-         We add our customized ones in the output flow.
-         As all our indexterm have @zone attributes, removed a lot of
-         unused code. -->
-    <!-- The original template is in {docbook-xsl}/xhtml/autoidx.xsl -->
-  <xsl:template match="indexterm" mode="reference">
-    <xsl:param name="scope" select="."/>
-    <xsl:call-template name="reference">
-      <xsl:with-param name="zones" select="normalize-space(@zone)"/>
-      <xsl:with-param name="scope" select="$scope"/>
-    </xsl:call-template>
   </xsl:template>
 
@@ -162,6 +149,6 @@
   <xsl:template match="indexterm" mode="index-primary">
     <xsl:param name="scope" select="."/>
-    <xsl:variable name="key" select="&primary;"/>
-    <xsl:variable name="refs" select="key('primary', $key)[&scope;]"/>
+    <xsl:variable name="key" select="normalize-space(concat(primary/@sortas, &quot; &quot;, primary))"/>
+    <xsl:variable name="refs" select="key('primary', $key)[count(ancestor::node()|$scope) = count(ancestor::node())]"/>
     <li>
       <strong class="item">
@@ -178,6 +165,5 @@
       <xsl:if test="$refs/secondary">
         <ul>
-          <xsl:apply-templates select="$refs[secondary and count(.|key('secondary', concat($key, &sep;, &secondary;))[&scope;][1]) = 1]"
-                               mode="index-secondary">
+          <xsl:apply-templates select="$refs[secondary and count(.|key('secondary', concat($key, &quot; &quot;, normalize-space(concat(secondary/@sortas, &quot; &quot;, secondary))))[count(ancestor::node()|$scope) = count(ancestor::node()) ][1]) = 1]" mode="index-secondary">
             <xsl:with-param name="scope" select="$scope"/>
             <xsl:sort select="translate(&secondary;, &lowercase;, &uppercase;)"/>
@@ -196,6 +182,6 @@
   <xsl:template match="indexterm" mode="index-secondary">
     <xsl:param name="scope" select="."/>
-    <xsl:variable name="key" select="concat(&primary;, &sep;, &secondary;)"/>
-    <xsl:variable name="refs" select="key('secondary', $key)[&scope;]"/>
+    <xsl:variable name="key" select="concat(normalize-space(concat(primary/@sortas, &quot; &quot;, primary)), &quot; &quot;, normalize-space(concat(secondary/@sortas, &quot; &quot;, secondary)))"/>
+    <xsl:variable name="refs" select="key('secondary', $key)[count(ancestor::node()|$scope) = count(ancestor::node())]"/>
     <li>
       <strong class="secitem">
@@ -213,12 +199,25 @@
   </xsl:template>
 
-    <!-- The target links:
-           Changed links separator.
-           On the second @zone link, we use a fixed string for the text
-           with gentext support.
-           Assume that there is no more than 2 @zone in a indexterm.
-           Use href.target.uri named template to resolve the links. It is faster
-           than the default href.target named template. -->
-    <!-- The original template is in {docbook-xsl}/xhtml/autoidx.xsl -->
+  <!-- Drop $term.separator and $number.separator from here as customized ones
+       are added in the output flow.
+       As all the indexterms in the book have @zone attributes, removed a lot of
+       unused code.
+       The original template is in {docbook-xsl}/xhtml/autoidx.xsl -->
+  <xsl:template match="indexterm" mode="reference">
+    <xsl:param name="scope" select="."/>
+    <xsl:call-template name="reference">
+      <xsl:with-param name="zones" select="normalize-space(@zone)"/>
+      <xsl:with-param name="scope" select="$scope"/>
+    </xsl:call-template>
+  </xsl:template>
+
+  <!-- The target links:
+       Changed link separator
+       On the second @zone link, we use a fixed string for the text with gentext
+       support.
+       Assume that there are no more than 2 @zone in a indexterm.
+       Use href.target.uri named template to resolve the links. It is faster
+       than the default href.target named template.
+       The original template is in {docbook-xsl}/xhtml/autoidx.xsl -->
   <xsl:template name="reference">
     <xsl:param name="scope" select="."/>
